package com.example.foodnowaster;

import android.app.Activity;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.HashMap;

public class ListFoodItemAdapter extends BaseAdapter {
    private Activity activity;
    private ArrayList<HashMap<String, String>> data;
    private DBHelper DB;

    public ListFoodItemAdapter(Activity a, ArrayList<HashMap<String, String>> d, DBHelper myDB) {
        activity = a;
        data = d;
        DB = myDB;
    }

    public int getCount() {
        return data.size();
    }

    public Object getItem(int position) {
        return position;
    }

    public long getItemId(int position) {
        return position;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        ListFoodItemViewHolder holder = null;
        if (convertView == null) {
            holder = new ListFoodItemViewHolder();
            //set layout for displaying items
            convertView = LayoutInflater.from(activity).inflate(R.layout.food_item_list_row, parent, false);
            //get food item name for food item view
            holder.foodItem_name = convertView.findViewById(R.id.foodItem_name);
            //get checkbox id name for food item view
            holder.checkBox = convertView.findViewById(R.id.checkBox);
            convertView.setTag(holder);
        } else {
            holder = (ListFoodItemViewHolder) convertView.getTag();
        }

        final HashMap<String, String> singleFoodItem = data.get(position);
        final ListFoodItemViewHolder tmpHolder = holder;

        holder.foodItem_name.setId(position);
        holder.checkBox.setId(position);

        try {
            holder.checkBox.setOnCheckedChangeListener(null);
            if (singleFoodItem.get("status").contentEquals("1")) {
                holder.foodItem_name.setText(Html.fromHtml("<strike>" + singleFoodItem.get("foodItem") + "</strike>"));
                holder.checkBox.setChecked(true);
            } else {
                holder.foodItem_name.setText(singleFoodItem.get("foodItem"));
                holder.checkBox.setChecked(false);
            }
            holder.checkBox.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                    if (isChecked) {
                        DB.updateFoodItemStatus(singleFoodItem.get("id"), 1);
                        tmpHolder.foodItem_name.setText(Html.fromHtml("<strike>" + singleFoodItem.get("foodItem") + "</strike>"));
                    } else {
                        DB.updateFoodItemStatus(singleFoodItem.get("id"), 0);
                        tmpHolder.foodItem_name.setText(singleFoodItem.get("foodItem"));
                    }
                }
            });
        } catch (Exception e) {
        }
        return convertView;
    }
}

class ListFoodItemViewHolder {
    TextView foodItem_name;
    CheckBox checkBox;
}