package com.example.foodnowaster;

import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.os.Build;

import androidx.core.app.NotificationCompat;
import androidx.core.app.NotificationManagerCompat;

//class extending the Broadcast Receiver
public class MyAlarm extends BroadcastReceiver {

    private static final String CHANNEL_ID = "FoodNoWasterChannel";

    //the method will be fired when the alarm is triggered
    @Override
    public void onReceive(Context context, Intent intent) {

        //check how many items to expire in two days in DB
        DBHelper mydb;
        mydb = new DBHelper(context);
        Cursor today = mydb.getTodayFoodItem();
        Cursor tomorrow = mydb.getTomorrowFoodItem();
        int upcomingItemsInTwoDays = today.getCount() + tomorrow.getCount();

        if (upcomingItemsInTwoDays > 0) {

            String message = "FoodNoWaster notification";

            Intent resultIntent = new Intent(context.getApplicationContext(), MainActivity.class);
            PendingIntent resultPendingIntent = PendingIntent.getActivity(context, 1, resultIntent, PendingIntent.FLAG_UPDATE_CURRENT);

            NotificationCompat.Builder builder = new NotificationCompat.Builder(context, "1")
                    .setSmallIcon(R.drawable.food_bank_notification)
                    .setContentTitle("Food items expiring within next two days:")
                    .setContentInfo(String.valueOf(upcomingItemsInTwoDays))
                    .setContentText(String.valueOf(upcomingItemsInTwoDays))
                    .setContentIntent(resultPendingIntent);

            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
                NotificationChannel channel = new NotificationChannel("1", "FoodNoWasterNumber", NotificationManager.IMPORTANCE_DEFAULT);
                channel.setDescription("FoodNoWasterNumber");
                NotificationManager manager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
                manager.createNotificationChannel(channel);
                manager.notify(1, builder.build());
            } else {
                NotificationManagerCompat managerCompat = NotificationManagerCompat.from(context);
                managerCompat.notify(1, builder.build());
            };
        }

    }

}